#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"
#include "Maths.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Lissajous 4", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    int centerX = SCREEN_WIDTH / 2;
    int centerY = SCREEN_HEIGHT/ 2;
    int radius = 200;

    float angleAdd = DEG_TO_RAD(40);

    for (int i = 0; i < 360; i++)
    {
        float angle0 = DEG_TO_RAD(i);
        int x0 = centerX + radius * cos(angle0);
        int y0 = centerY + radius * sin(2.0 * angle0 + angleAdd);

        float angle1 = DEG_TO_RAD(i + 1);
        int x1 = centerX + radius * cos(angle1);
        int y1 = centerY + radius * sin(2.0 * angle1 + angleAdd);

        gfx.line(x0, y0, x1, y1, Color(255, 255, 255));

        gfx.render();
        sys.wait(20);
    }

    // wait until we quit
    while (sys.isQuitRequested() == false)
    {
        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
